<?php
if (function_exists('add_theme_support')) {
    add_theme_support('post-thumbnails');
    add_image_size('index-categories', 150, 150, true);
    add_image_size('page-single', 350, 350, true);
}
?>
<?php
function de_slider_height(){
?>
<?php 
if (get_admin_options("fgalinfoheight") == '')
{
?>
<style type="text/css">
.nivo-caption{
height: 40px;
} 
</style>
<?php
} 
else{
?>
<style type="text/css">
.nivo-caption{
height: <?php echo get_admin_options('fgalinfoheight'); ?>px;
} 
</style>
<?php
}
?>
<?php
}
    add_action('wp_head','de_slider_height');  
?>
<?php
function de_sliderinfo_fonts(){
?>
<?php 
if (get_admin_options("fgalinfofonts") == '')
{
?>
<style type="text/css">
.nivo-caption{
font-size:12px;
} 
</style>
<?php
} 
else{
?>
<style type="text/css">
.nivo-caption{
font-size: <?php echo get_admin_options('fgalinfofonts'); ?>px;
} 
</style>
<?php
}
?>
<?php
}
    add_action('wp_head','de_sliderinfo_fonts');  
?>
<?php
function de_more_button_alignment(){
?>
<?php 
if (get_admin_options("morebtnalignment") == '')
{
?>
<style type="text/css">
.readmore-wrap{
float:left;
} 
</style>
<?php
} 
else{
?>
<style type="text/css">
.readmore-wrap{
float: <?php echo get_admin_options('morebtnalignment'); ?>;
} 
</style>
<?php
}
?>
<?php
}
    add_action('wp_head','de_more_button_alignment');  
?>
<?php
add_theme_support( 'nav-menus' );
function add_wp3menu_support() {
register_nav_menus(
        array(
        'first-menu' => __('First Menu'),
        'second-menu' => __('Second Menu')
        )
     );
 
}
add_action('init', 'add_wp3menu_support');
?>
<?php
add_filter( 'wp_nav_menu_items', 'add_home_link', 10, 2 );
function add_home_link($items, $args) { 
        if (is_front_page())
            $class = 'class="current_page_item"';
        else
            $class = ''; 
        $homeMenuItem =
                '<li ' . $class . '>' .
                $args->before .
                '<a href="' . home_url( '/' ) . '" title="Home">' .
                $args->link_before . 'Home' . $args->link_after .
                '</a>' .
                $args->after .
                '</li>'; 
        $items = $homeMenuItem . $items; 
    return $items;
}
?>
<?php
function dimox_breadcrumbs() { 
  $delimiter = '&raquo;';
  $home = 'Home'; // text for the 'Home' link
  $before = '<span class="current">'; // tag before the current crumb
  $after = '</span>'; // tag after the current crumb 
  if ( !is_home() && !is_front_page() || is_paged() ) { 
    echo '<div id="crumbs">'; 
    global $post;
    $homeLink = get_bloginfo('url');
    echo '<a href="' . $homeLink . '">' . $home . '</a> ' . $delimiter . ' '; 
    if ( is_category() ) {
      global $wp_query;
      $cat_obj = $wp_query->get_queried_object();
      $thisCat = $cat_obj->term_id;
      $thisCat = get_category($thisCat);
      $parentCat = get_category($thisCat->parent);
      if ($thisCat->parent != 0) echo(get_category_parents($parentCat, TRUE, ' ' . $delimiter . ' '));
      echo $before . 'Archive by category "' . single_cat_title('', false) . '"' . $after; 
    } elseif ( is_day() ) {
      echo '<a href="' . get_year_link(get_the_time('Y')) . '">' . get_the_time('Y') . '</a> ' . $delimiter . ' ';
      echo '<a href="' . get_month_link(get_the_time('Y'),get_the_time('m')) . '">' . get_the_time('F') . '</a> ' . $delimiter . ' ';
      echo $before . get_the_time('d') . $after; 
    } elseif ( is_month() ) {
      echo '<a href="' . get_year_link(get_the_time('Y')) . '">' . get_the_time('Y') . '</a> ' . $delimiter . ' ';
      echo $before . get_the_time('F') . $after; 
    } elseif ( is_year() ) {
      echo $before . get_the_time('Y') . $after; 
    } elseif ( is_single() && !is_attachment() ) {
      if ( get_post_type() != 'post' ) {
        $post_type = get_post_type_object(get_post_type());
        $slug = $post_type->rewrite;
        echo '<a href="' . $homeLink . '/' . $slug['slug'] . '/">' . $post_type->labels->singular_name . '</a> ' . $delimiter . ' ';
        echo $before . get_the_title() . $after;
      } else {
        $cat = get_the_category(); $cat = $cat[0];
        echo get_category_parents($cat, TRUE, ' ' . $delimiter . ' ');
        echo $before . get_the_title() . $after;
     } 
    } elseif ( !is_single() && !is_page() && get_post_type() != 'post' && !is_404() ) {
      $post_type = get_post_type_object(get_post_type());
      echo $before . $post_type->labels->singular_name . $after; 
    } elseif ( is_attachment() ) {
      $parent = get_post($post->post_parent);
      $cat = get_the_category($parent->ID); $cat = $cat[0];
      echo get_category_parents($cat, TRUE, ' ' . $delimiter . ' ');
      echo '<a href="' . get_permalink($parent) . '">' . $parent->post_title . '</a> ' . $delimiter . ' ';
      echo $before . get_the_title() . $after; 
    } elseif ( is_page() && !$post->post_parent ) {
      echo $before . get_the_title() . $after; 
    } elseif ( is_page() && $post->post_parent ) {
      $parent_id  = $post->post_parent;
      $breadcrumbs = array();
      while ($parent_id) {
        $page = get_page($parent_id);
        $breadcrumbs[] = '<a href="' . get_permalink($page->ID) . '">' . get_the_title($page->ID) . '</a>';
        $parent_id  = $page->post_parent;      }
      $breadcrumbs = array_reverse($breadcrumbs);
      foreach ($breadcrumbs as $crumb) echo $crumb . ' ' . $delimiter . ' ';
      echo $before . get_the_title() . $after; 
    } elseif ( is_search() ) {
      echo $before . 'Search results for "' . get_search_query() . '"' . $after; 
    } elseif ( is_tag() ) {
      echo $before . 'Posts tagged "' . single_tag_title('', false) . '"' . $after; 
    } elseif ( is_author() ) {
       global $author;
      $userdata = get_userdata($author);
      echo $before . 'Articles posted by ' . $userdata->display_name . $after; 
    } elseif ( is_404() ) {
      echo $before . 'Error 404' . $after;
    } 
    if ( get_query_var('paged') ) {
      if ( is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author() ) echo ' (';
      echo __('Page') . ' ' . get_query_var('paged');
      if ( is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author() ) echo ')';
    } 
    echo '</div>'; 
  }
} // end dimox_breadcrumbs()
?>